VTK: vtkAbstractInterpolatedVelocityField Class Reference

| VTK 9.3.1

Classes | Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes | Friends | List of all members
vtkAbstractInterpolatedVelocityField Class Referenceabstract

An abstract class for obtaining the interpolated velocity values at a point. More...

`#include <vtkAbstractInterpolatedVelocityField.h>`

Inheritance diagram for vtkAbstractInterpolatedVelocityField:
[legend]
Collaboration diagram for vtkAbstractInterpolatedVelocityField:
[legend]

## Classes
struct | vtkDataSetInformation

## Public Types
enum | VelocityFieldInitializationState { NOT_INITIALIZED = 0 , INITIALIZE_ALL_DATASETS = 1 , SELF_INITIALIZE = 2 }
Public Types inherited from vtkFunctionSet
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkDataSet * | GetLastDataSet ()
virtual void | SetLastCellId (vtkIdType c, int dataindex)=0
| Set the id of the most recently visited cell of a dataset. More...
void | SelectVectors (int fieldAssociation, const char *fieldName)
| the association type (see vtkDataObject::FieldAssociations) and the name of the velocity data field More...
virtual void | CopyParameters (vtkAbstractInterpolatedVelocityField *from)
| Copy essential parameters between instances of this class. More...
int | FunctionValues (double *x, double *f) override=0
| Evaluate the velocity field f at point (x, y, z). More...
void | ClearLastCellId ()
| Set the last cell id to -1 to incur a global cell search for the next point. More...
virtual void | Initialize (vtkCompositeDataSet *compDS, int initStrategy=INITIALIZE_ALL_DATASETS)
| The Initialize() method is used to build and cache supporting structures (such as locators) which are used when operating on the interpolated velocity field. More...
virtual int | GetInitializationState ()
| The Initialize() method is used to build and cache supporting structures (such as locators) which are used when operating on the interpolated velocity field. More...
virtual void | SetCaching (bool)
| Set/Get the caching flag. More...
virtual bool | GetCaching ()
| Set/Get the caching flag. More...
virtual int | GetCacheHit ()
| Get the caching statistics. More...
virtual int | GetCacheMiss ()
| Get the caching statistics. More...
virtual vtkIdType | GetLastCellId ()
| Get/Set the id of the cell cached from last evaluation. More...
virtual void | SetLastCellId (vtkIdType c)
| Get/Set the id of the cell cached from last evaluation. More...
virtual char * | GetVectorsSelection ()
| Get/Set the name of a specified vector array. More...
virtual int | GetVectorsType ()
| Get/Set the name of a specified vector array. More...
virtual void | SetNormalizeVector (bool)
| Set/Get the flag indicating vector post-normalization (following vector interpolation). More...
virtual bool | GetNormalizeVector ()
| Set/Get the flag indicating vector post-normalization (following vector interpolation). More...
virtual void | SetForceSurfaceTangentVector (bool)
| If set to true, the first three point of the cell will be used to compute a normal to the cell, this normal will then be removed from the vorticity so the resulting vector in tangent to the cell. More...
virtual bool | GetForceSurfaceTangentVector ()
| If set to true, the first three point of the cell will be used to compute a normal to the cell, this normal will then be removed from the vorticity so the resulting vector in tangent to the cell. More...
virtual void | SetSurfaceDataset (bool)
| If set to true, cell within tolerance factor will always be found, except for edges. More...
virtual bool | GetSurfaceDataset ()
| If set to true, cell within tolerance factor will always be found, except for edges. More...
int | GetLastWeights (double *w)
| Get the interpolation weights cached from last evaluation. More...
int | GetLastLocalCoordinates (double pcoords[3])
| Get the interpolation weights cached from last evaluation. More...
virtual void | SetFindCellStrategy (vtkFindCellStrategy *)
| Set / get the strategy used to perform the FindCell() operation. More...
virtual vtkFindCellStrategy * | GetFindCellStrategy ()
| Set / get the strategy used to perform the FindCell() operation. More...
Public Member Functions inherited from vtkFunctionSet
vtkFunctionSet * | NewInstance () const
virtual int | FunctionValues (double *x, double *f, void *vtkNotUsed(userData))
virtual int | GetNumberOfFunctions ()
| Return the number of functions. More...
virtual int | GetNumberOfIndependentVariables ()
| Return the number of independent variables. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Protected Member Functions
| vtkAbstractInterpolatedVelocityField ()
| ~vtkAbstractInterpolatedVelocityField () override
virtual int | FunctionValues (vtkDataSet *ds, double *x, double *f)
| Evaluate the velocity field f at point (x, y, z) in a specified dataset by invoking vtkDataSet::FindCell() to locate the next cell if the given point is outside the current cell. More...
virtual bool | FindAndUpdateCell (vtkDataSet *ds, vtkFindCellStrategy *strategy, double *x)
| Try to find the cell closest to provided x point in provided dataset, By first testing inclusion in it's cached cell and neighbor Then testing globally. More...
virtual void | SetVectorsSelection (const char *)
| Set the name of a specific vector to be interpolated. More...
void | FastCompute (vtkDataArray *vectors, double f[3])
| If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell. More...
void | FastCompute (vtkAbstractInterpolatedVelocityField *inIVF, vtkDataArray *vectors, double f[3])
| If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell. More...
bool | InterpolatePoint (vtkPointData *outPD, vtkIdType outIndex)
| If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell. More...
bool | InterpolatePoint (vtkAbstractInterpolatedVelocityField *inIVF, vtkPointData *outPD, vtkIdType outIndex)
| If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell. More...
vtkGenericCell * | GetLastCell ()
| If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell. More...
virtual int | SelfInitialize ()
| These methods pertain to initializing the vector field by subclasses (which may have special initialization needs). More...
void | AddToDataSetsInfo (vtkDataSet *, vtkFindCellStrategy *, vtkDataArray *vectors)
| These methods pertain to initializing the vector field by subclasses (which may have special initialization needs). More...
size_t | GetDataSetsInfoSize ()
| These methods pertain to initializing the vector field by subclasses (which may have special initialization needs). More...
Protected Member Functions inherited from vtkFunctionSet
| vtkFunctionSet ()
| ~vtkFunctionSet () override=default
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | CacheHit
int | CacheMiss
bool | Caching
bool | NormalizeVector
bool | ForceSurfaceTangentVector
bool | SurfaceDataset
int | VectorsType
char * | VectorsSelection
std::vector< double > | Weights
double | LastPCoords [3]
int | LastSubId
double | LastClosestPoint [3]
vtkIdType | LastCellId
vtkDataSet * | LastDataSet
vtkNew< vtkGenericCell > | LastCell
vtkNew< vtkGenericCell > | CurrentCell
vtkNew< vtkIdList > | PointIds
int | InitializationState
| Make sure the velocity field is initialized: record the initialization strategy. More...
Protected Attributes inherited from vtkFunctionSet
int | NumFuncs
int | NumIndepVars
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Static Protected Attributes
static const double | TOLERANCE_SCALE
static const double | SURFACE_TOLERANCE_SCALE

## Friends
class | vtkTemporalInterpolatedVelocityField
typedef vtkFunctionSet | Superclass
| Standard methods for obtaining type information and printing the object state. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for obtaining type information and printing the object state. More...
static vtkAbstractInterpolatedVelocityField * | SafeDownCast (vtkObjectBase *o)
| Standard methods for obtaining type information and printing the object state. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for obtaining type information and printing the object state. More...
vtkAbstractInterpolatedVelocityField * | NewInstance () const
| Standard methods for obtaining type information and printing the object state. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for obtaining type information and printing the object state. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for obtaining type information and printing the object state. More...
vtkFindCellStrategy * | FindCellStrategy
| Define a FindCell() strategy, keep track of the strategies (and other cached information) associated with each dataset. More...
std::vector< vtkDataSetInformation > | DataSetsInfo
| Define a FindCell() strategy, keep track of the strategies (and other cached information) associated with each dataset. More...
std::vector< vtkDataSetInformation >::iterator | GetDataSetInfo (vtkDataSet *dataset)
| Define a FindCell() strategy, keep track of the strategies (and other cached information) associated with each dataset. More...

## Additional Inherited Members
Static Public Member Functions inherited from vtkFunctionSet
static vtkTypeBool | IsTypeOf (const char *type)
static vtkFunctionSet * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

An abstract class for obtaining the interpolated velocity values at a point.

vtkAbstractInterpolatedVelocityField acts as a continuous velocity field by performing cell interpolation on the underlying vtkDataSet (or in the case of vtkCompositeInterpolatedVelocityField, vtkCompositeDataSets). This is an abstract sub-class of vtkFunctionSet, NumberOfIndependentVariables = 4 (x,y,z,t) and NumberOfFunctions = 3 (u,v,w). With a brute-force scheme, every time an evaluation is performed, the target cell containing point (x,y,z) needs to be found by calling FindCell(); however vtkAbstractInterpolatedVelocityField uses locators to accelerate this operation via an instance of vtkFindCellStrategy. Even with the use of locators, the cost of the find cell operation can be large, hence this class performs local caching to reduce the number of invocations of FindCell(). As a result, this class is not thread safe as it contains local state (such as the cache information). Writing a threaded operations requires separate instances of vtkAbstractInterpolatedVelocityField for each thread.

For vtkCompositeInterpolatedVelocityField with CLOSEST_POINT strategy, level #0 begins with intra-cell caching. Specifically if the previous cell is valid and the next point is still in it ( i.e., vtkCell::EvaluatePosition() returns 1, coupled with newly created parametric coordinates & weights ), the function values can be interpolated and only vtkCell::EvaluatePosition() is invoked. If this fails, then level #1 follows by inter-cell search for the target cell that contains the next point. By an inter-cell search, the previous cell provides an important clue or serves as an immediate neighbor to aid in locating the target cell via vtkPointSet:: FindCell(). If this still fails, a global cell location / search is invoked via vtkFindCellStrategy. Finally, if this operation fails, the streamline is considered terminated.

Note the particular find cell strategy employed can affect the behavior of this class. If the strategy involved using a point locator (e.g., vtkStaticPointLocator or vtkPointLocator via vtkClosestPointStrategy or vtkClosestNPointsStrategy) the performance of the class improves to the detriment of robustness. Using a cell locator (e.g., vtkStaticCellLocator or vtkCellLocator via vtkCellLocatorStrategy) improves robustness at some cost to performance. Originally, these different behaviors (i.e., using different locators) was codified into different subclasses of vtkAbstractInterpolatedVelocityField.

Note that topologically structured classes such as vtkImageData and vtkRectilinearGrid are able to provide fast robust cell location. Hence the specified find cell strategy is only applicable to subclasses of vtkPointSet (such as vtkUnstructuredGrid).

Warning
  vtkAbstractInterpolatedVelocityField is not thread safe. A new instance should be created by each thread.

See also
  vtkCompositeInterpolatedVelocityField vtkAMRInterpolatedVelocityField vtkGenericInterpolatedVelocityField vtkCachingInterpolatedVelocityField vtkTemporalInterpolatedVelocityField vtkFunctionSet vtkStreamTracer vtkFindCellStrategy

Definition at line 88 of file vtkAbstractInterpolatedVelocityField.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkFunctionSet vtkAbstractInterpolatedVelocityField::Superclass

Standard methods for obtaining type information and printing the object state.

Definition at line 95 of file vtkAbstractInterpolatedVelocityField.h.

## Member Enumeration Documentation

## ◆ VelocityFieldInitializationState

enum vtkAbstractInterpolatedVelocityField::VelocityFieldInitializationState

Enumerator
NOT_INITIALIZED |
INITIALIZE_ALL_DATASETS |
SELF_INITIALIZE |

Definition at line 103 of file vtkAbstractInterpolatedVelocityField.h.

## Constructor & Destructor Documentation

## ◆ vtkAbstractInterpolatedVelocityField()

vtkAbstractInterpolatedVelocityField::vtkAbstractInterpolatedVelocityField | ( |  | ) |
| protected

## ◆ ~vtkAbstractInterpolatedVelocityField()

vtkAbstractInterpolatedVelocityField::~vtkAbstractInterpolatedVelocityField | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkAbstractInterpolatedVelocityField::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods for obtaining type information and printing the object state.

## ◆ IsA()

virtual vtkTypeBool vtkAbstractInterpolatedVelocityField::IsA | ( | const char * | type | ) |
| virtual

Standard methods for obtaining type information and printing the object state.

Reimplemented from vtkFunctionSet.

Reimplemented in vtkInterpolatedVelocityField, vtkCompositeInterpolatedVelocityField, vtkCellLocatorInterpolatedVelocityField, and vtkAMRInterpolatedVelocityField.

## ◆ SafeDownCast()

static vtkAbstractInterpolatedVelocityField* vtkAbstractInterpolatedVelocityField::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods for obtaining type information and printing the object state.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkAbstractInterpolatedVelocityField::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for obtaining type information and printing the object state.

Reimplemented from vtkFunctionSet.

Reimplemented in vtkInterpolatedVelocityField, vtkCompositeInterpolatedVelocityField, vtkCellLocatorInterpolatedVelocityField, and vtkAMRInterpolatedVelocityField.

## ◆ NewInstance()

vtkAbstractInterpolatedVelocityField* vtkAbstractInterpolatedVelocityField::NewInstance | ( |  | ) | const

Standard methods for obtaining type information and printing the object state.

## ◆ PrintSelf()

void vtkAbstractInterpolatedVelocityField::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for obtaining type information and printing the object state.

Reimplemented from vtkFunctionSet.

Reimplemented in vtkInterpolatedVelocityField, vtkCompositeInterpolatedVelocityField, vtkCellLocatorInterpolatedVelocityField, and vtkAMRInterpolatedVelocityField.

## ◆ Initialize()

virtual void vtkAbstractInterpolatedVelocityField::Initialize | ( | vtkCompositeDataSet * | compDS,
|  | int | initStrategy = `INITIALIZE_ALL_DATASETS`
| ) |  |
| virtual

The Initialize() method is used to build and cache supporting structures (such as locators) which are used when operating on the interpolated velocity field.

This method is needed mainly to deal with thread safety issues; i.e., these supporting structures must be built at the right time to avoid race conditions. Currently this method is used by vtkStreamTracer (and related classes) which process composite datasets (in the future other dataset types may be supported). Also, a initialization strategy can be specified which controls how the initialization process functions (this is a API placeholder for the future). Note that some subclasses may override the initialize method (via SelfInitialize()) because they have special methods of setting up the interpolated velocity field.

## ◆ GetInitializationState()

virtual int vtkAbstractInterpolatedVelocityField::GetInitializationState | ( |  | ) |
| virtual

The Initialize() method is used to build and cache supporting structures (such as locators) which are used when operating on the interpolated velocity field.

This method is needed mainly to deal with thread safety issues; i.e., these supporting structures must be built at the right time to avoid race conditions. Currently this method is used by vtkStreamTracer (and related classes) which process composite datasets (in the future other dataset types may be supported). Also, a initialization strategy can be specified which controls how the initialization process functions (this is a API placeholder for the future). Note that some subclasses may override the initialize method (via SelfInitialize()) because they have special methods of setting up the interpolated velocity field.

## ◆ SetCaching()

virtual void vtkAbstractInterpolatedVelocityField::SetCaching | ( | bool |  | ) |
| virtual

Set/Get the caching flag.

If this flag is turned ON, there are two levels of caching for when the strategy is CLOSEST_POINT and one level of caching when the strategy is CELL_LOCATOR. Otherwise a global cell location is always invoked for evaluating the function values at any point.

## ◆ GetCaching()

virtual bool vtkAbstractInterpolatedVelocityField::GetCaching | ( |  | ) |
| virtual

Set/Get the caching flag.

If this flag is turned ON, there are two levels of caching for when the strategy is CLOSEST_POINT and one level of caching when the strategy is CELL_LOCATOR. Otherwise a global cell location is always invoked for evaluating the function values at any point.

## ◆ GetCacheHit()

virtual int vtkAbstractInterpolatedVelocityField::GetCacheHit | ( |  | ) |
| virtual

Get the caching statistics.

CacheHit refers to the number of level #0 cache hits while CacheMiss is the number of level #0 cache misses.

## ◆ GetCacheMiss()

virtual int vtkAbstractInterpolatedVelocityField::GetCacheMiss | ( |  | ) |
| virtual

Get the caching statistics.

CacheHit refers to the number of level #0 cache hits while CacheMiss is the number of level #0 cache misses.

## ◆ GetLastDataSet()

virtual vtkDataSet* vtkAbstractInterpolatedVelocityField::GetLastDataSet | ( |  | ) |
| virtual

## ◆ GetLastCellId()

virtual vtkIdType vtkAbstractInterpolatedVelocityField::GetLastCellId | ( |  | ) |
| virtual

Get/Set the id of the cell cached from last evaluation.

## ◆ SetLastCellId() [1/2]

virtual void vtkAbstractInterpolatedVelocityField::SetLastCellId | ( | vtkIdType | c | ) |
| inlinevirtual

Get/Set the id of the cell cached from last evaluation.

Reimplemented in vtkCompositeInterpolatedVelocityField, and vtkAMRInterpolatedVelocityField.

Definition at line 156 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ SetLastCellId() [2/2]

virtual void vtkAbstractInterpolatedVelocityField::SetLastCellId | ( | vtkIdType | c,
|  | int | dataindex
| ) |  |
| pure virtual

Set the id of the most recently visited cell of a dataset.

Implemented in vtkCompositeInterpolatedVelocityField, and vtkAMRInterpolatedVelocityField.

## ◆ GetVectorsSelection()

virtual char* vtkAbstractInterpolatedVelocityField::GetVectorsSelection | ( |  | ) |
| virtual

Get/Set the name of a specified vector array.

By default it is nullptr, with the active vector array for use.

## ◆ GetVectorsType()

virtual int vtkAbstractInterpolatedVelocityField::GetVectorsType | ( |  | ) |
| virtual

Get/Set the name of a specified vector array.

By default it is nullptr, with the active vector array for use.

## ◆ SelectVectors()

void vtkAbstractInterpolatedVelocityField::SelectVectors | ( | int | fieldAssociation,
|  | const char * | fieldName
| ) |  |

the association type (see vtkDataObject::FieldAssociations) and the name of the velocity data field

## ◆ SetNormalizeVector()

virtual void vtkAbstractInterpolatedVelocityField::SetNormalizeVector | ( | bool |  | ) |
| virtual

Set/Get the flag indicating vector post-normalization (following vector interpolation).

Vector post-normalization is required to avoid the 'curve-overshooting' problem (caused by high velocity magnitude) that occurs when Cell-Length is used as the step size unit (particularly the Minimum step size unit). Furthermore, it is required by RK45 to achieve, as expected, high numerical accuracy (or high smoothness of flow lines) through adaptive step sizing. Note this operation is performed (when NormalizeVector TRUE) right after vector interpolation such that the differing amount of contribution of each node (of a cell) to the resulting direction of the interpolated vector, due to the possibly significantly-differing velocity magnitude values at the nodes (which is the case with large cells), can be reflected as is. Also note that this flag needs to be turned to FALSE after vtkInitialValueProblemSolver:: ComputeNextStep() as subsequent operations, e.g., vorticity computation, may need non-normalized vectors.

## ◆ GetNormalizeVector()

virtual bool vtkAbstractInterpolatedVelocityField::GetNormalizeVector | ( |  | ) |
| virtual

Set/Get the flag indicating vector post-normalization (following vector interpolation).

Vector post-normalization is required to avoid the 'curve-overshooting' problem (caused by high velocity magnitude) that occurs when Cell-Length is used as the step size unit (particularly the Minimum step size unit). Furthermore, it is required by RK45 to achieve, as expected, high numerical accuracy (or high smoothness of flow lines) through adaptive step sizing. Note this operation is performed (when NormalizeVector TRUE) right after vector interpolation such that the differing amount of contribution of each node (of a cell) to the resulting direction of the interpolated vector, due to the possibly significantly-differing velocity magnitude values at the nodes (which is the case with large cells), can be reflected as is. Also note that this flag needs to be turned to FALSE after vtkInitialValueProblemSolver:: ComputeNextStep() as subsequent operations, e.g., vorticity computation, may need non-normalized vectors.

## ◆ SetForceSurfaceTangentVector()

virtual void vtkAbstractInterpolatedVelocityField::SetForceSurfaceTangentVector | ( | bool |  | ) |
| virtual

If set to true, the first three point of the cell will be used to compute a normal to the cell, this normal will then be removed from the vorticity so the resulting vector in tangent to the cell.

This means that the input dataset should only contains 2D planar cells.

## ◆ GetForceSurfaceTangentVector()

virtual bool vtkAbstractInterpolatedVelocityField::GetForceSurfaceTangentVector | ( |  | ) |
| virtual

If set to true, the first three point of the cell will be used to compute a normal to the cell, this normal will then be removed from the vorticity so the resulting vector in tangent to the cell.

This means that the input dataset should only contains 2D planar cells.

## ◆ SetSurfaceDataset()

virtual void vtkAbstractInterpolatedVelocityField::SetSurfaceDataset | ( | bool |  | ) |
| virtual

If set to true, cell within tolerance factor will always be found, except for edges.

Please note 2D planar cells are expected.

## ◆ GetSurfaceDataset()

virtual bool vtkAbstractInterpolatedVelocityField::GetSurfaceDataset | ( |  | ) |
| virtual

If set to true, cell within tolerance factor will always be found, except for edges.

Please note 2D planar cells are expected.

## ◆ CopyParameters()

virtual void vtkAbstractInterpolatedVelocityField::CopyParameters | ( | vtkAbstractInterpolatedVelocityField * | from | ) |
| virtual

Copy essential parameters between instances of this class.

This generally is used to copy from instance prototype to another, or to copy interpolators between thread instances. Sub-classes can contribute to the parameter copying process via chaining.

Reimplemented in vtkCompositeInterpolatedVelocityField, and vtkAMRInterpolatedVelocityField.

## ◆ FunctionValues() [1/2]

int vtkAbstractInterpolatedVelocityField::FunctionValues | ( | double * | x,
|  | double * | f
| ) |  |
| overridepure virtual

Evaluate the velocity field f at point (x, y, z).

Reimplemented from vtkFunctionSet.

Implemented in vtkCompositeInterpolatedVelocityField, and vtkAMRInterpolatedVelocityField.

## ◆ ClearLastCellId()

void vtkAbstractInterpolatedVelocityField::ClearLastCellId | ( |  | ) |
| inline

Set the last cell id to -1 to incur a global cell search for the next point.

Definition at line 239 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ GetLastWeights()

int vtkAbstractInterpolatedVelocityField::GetLastWeights | ( | double * | w | ) |

Get the interpolation weights cached from last evaluation.

Return 1 if the cached cell is valid and 0 otherwise.

## ◆ GetLastLocalCoordinates()

int vtkAbstractInterpolatedVelocityField::GetLastLocalCoordinates | ( | double | pcoords[3] | ) |

Get the interpolation weights cached from last evaluation.

Return 1 if the cached cell is valid and 0 otherwise.

## ◆ SetFindCellStrategy()

virtual void vtkAbstractInterpolatedVelocityField::SetFindCellStrategy | ( | vtkFindCellStrategy * |  | ) |
| virtual

Set / get the strategy used to perform the FindCell() operation.

This strategy is used when operating on vtkPointSet subclasses. Note if the input is a composite dataset then the strategy will be used to clone one strategy per leaf dataset.

## ◆ GetFindCellStrategy()

virtual vtkFindCellStrategy* vtkAbstractInterpolatedVelocityField::GetFindCellStrategy | ( |  | ) |
| virtual

Set / get the strategy used to perform the FindCell() operation.

This strategy is used when operating on vtkPointSet subclasses. Note if the input is a composite dataset then the strategy will be used to clone one strategy per leaf dataset.

## ◆ GetDataSetInfo()

std::vector<vtkDataSetInformation>::iterator vtkAbstractInterpolatedVelocityField::GetDataSetInfo | ( | vtkDataSet * | dataset | ) |
| protected

Define a FindCell() strategy, keep track of the strategies (and other cached information) associated with each dataset.

## ◆ SetVectorsSelection()

virtual void vtkAbstractInterpolatedVelocityField::SetVectorsSelection | ( | const char * |  | ) |
| protectedvirtual

Set the name of a specific vector to be interpolated.

## ◆ FunctionValues() [2/2]

virtual int vtkAbstractInterpolatedVelocityField::FunctionValues | ( | vtkDataSet * | ds,
|  | double * | x,
|  | double * | f
| ) |  |
| protectedvirtual

Evaluate the velocity field f at point (x, y, z) in a specified dataset by invoking vtkDataSet::FindCell() to locate the next cell if the given point is outside the current cell.

To address vtkPointSet, vtkPointLocator is involved via vtkPointSet::FindCell() using CLOSEST_POINT strategy for cell location. In vtkCompositeInterpolatedVelocityField with a CELL_LOCATOR strategy, this function is invoked just to handle vtkImageData and vtkRectilinearGrid that are not assigned with any vtkAbstractCellLocator-type cell locator. If activated, returned vector will be tangential to the first three point of the cell

Reimplemented in vtkCompositeInterpolatedVelocityField, and vtkAMRInterpolatedVelocityField.

## ◆ FindAndUpdateCell()

virtual bool vtkAbstractInterpolatedVelocityField::FindAndUpdateCell | ( | vtkDataSet * | ds,
|  | vtkFindCellStrategy * | strategy,
|  | double * | x
| ) |  |
| protectedvirtual

Try to find the cell closest to provided x point in provided dataset, By first testing inclusion in it's cached cell and neighbor Then testing globally.

Then, only if surface is activated finding the closest cell using FindClosestPointWithinRadius

## ◆ FastCompute() [1/2]

void vtkAbstractInterpolatedVelocityField::FastCompute | ( | vtkDataArray * | vectors,
|  | double | f[3]
| ) |  |
| protected

If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell.

This function is primarily reserved for use by vtkTemporalInterpolatedVelocityField

## ◆ FastCompute() [2/2]

void vtkAbstractInterpolatedVelocityField::FastCompute | ( | vtkAbstractInterpolatedVelocityField * | inIVF,
|  | vtkDataArray * | vectors,
|  | double | f[3]
| ) |  |
| protected

If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell.

This function is primarily reserved for use by vtkTemporalInterpolatedVelocityField

## ◆ InterpolatePoint() [1/2]

bool vtkAbstractInterpolatedVelocityField::InterpolatePoint | ( | vtkPointData * | outPD,
|  | vtkIdType | outIndex
| ) |  |
| protected

If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell.

This function is primarily reserved for use by vtkTemporalInterpolatedVelocityField

## ◆ InterpolatePoint() [2/2]

bool vtkAbstractInterpolatedVelocityField::InterpolatePoint | ( | vtkAbstractInterpolatedVelocityField * | inIVF,
|  | vtkPointData * | outPD,
|  | vtkIdType | outIndex
| ) |  |
| protected

If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell.

This function is primarily reserved for use by vtkTemporalInterpolatedVelocityField

## ◆ GetLastCell()

vtkGenericCell* vtkAbstractInterpolatedVelocityField::GetLastCell | ( |  | ) |
| inlineprotected

If all weights have been computed (parametric coords etc all valid), a scalar/vector can be quickly interpolated using the known weights and the cached generic cell.

This function is primarily reserved for use by vtkTemporalInterpolatedVelocityField

Definition at line 360 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ SelfInitialize()

virtual int vtkAbstractInterpolatedVelocityField::SelfInitialize | ( |  | ) |
| inlineprotectedvirtual

These methods pertain to initializing the vector field by subclasses (which may have special initialization needs).

The first allows a subclass to perform additional initialization. The second enabled the subclass to add a dataset, find cell strtegy, and associated vectors to FunctionHashMap.

Reimplemented in vtkAMRInterpolatedVelocityField.

Definition at line 373 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ AddToDataSetsInfo()

void vtkAbstractInterpolatedVelocityField::AddToDataSetsInfo | ( | vtkDataSet * | ,
|  | vtkFindCellStrategy * | ,
|  | vtkDataArray * | vectors
| ) |  |
| protected

These methods pertain to initializing the vector field by subclasses (which may have special initialization needs).

The first allows a subclass to perform additional initialization. The second enabled the subclass to add a dataset, find cell strtegy, and associated vectors to FunctionHashMap.

## ◆ GetDataSetsInfoSize()

size_t vtkAbstractInterpolatedVelocityField::GetDataSetsInfoSize | ( |  | ) |
| protected

These methods pertain to initializing the vector field by subclasses (which may have special initialization needs).

The first allows a subclass to perform additional initialization. The second enabled the subclass to add a dataset, find cell strtegy, and associated vectors to FunctionHashMap.

## Friends And Related Function Documentation

## ◆ vtkTemporalInterpolatedVelocityField

friend class vtkTemporalInterpolatedVelocityField
| friend

Definition at line 347 of file vtkAbstractInterpolatedVelocityField.h.

## Member Data Documentation

## ◆ TOLERANCE_SCALE

const double vtkAbstractInterpolatedVelocityField::TOLERANCE_SCALE
| staticprotected

Definition at line 265 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ SURFACE_TOLERANCE_SCALE

const double vtkAbstractInterpolatedVelocityField::SURFACE_TOLERANCE_SCALE
| staticprotected

Definition at line 266 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ CacheHit

int vtkAbstractInterpolatedVelocityField::CacheHit
| protected

Definition at line 268 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ CacheMiss

int vtkAbstractInterpolatedVelocityField::CacheMiss
| protected

Definition at line 269 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ Caching

bool vtkAbstractInterpolatedVelocityField::Caching
| protected

Definition at line 270 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ NormalizeVector

bool vtkAbstractInterpolatedVelocityField::NormalizeVector
| protected

Definition at line 271 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ ForceSurfaceTangentVector

bool vtkAbstractInterpolatedVelocityField::ForceSurfaceTangentVector
| protected

Definition at line 272 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ SurfaceDataset

bool vtkAbstractInterpolatedVelocityField::SurfaceDataset
| protected

Definition at line 273 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ VectorsType

int vtkAbstractInterpolatedVelocityField::VectorsType
| protected

Definition at line 274 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ VectorsSelection

char* vtkAbstractInterpolatedVelocityField::VectorsSelection
| protected

Definition at line 275 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ Weights

std::vector<double> vtkAbstractInterpolatedVelocityField::Weights
| protected

Definition at line 276 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ LastPCoords

double vtkAbstractInterpolatedVelocityField::LastPCoords[3]
| protected

Definition at line 277 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ LastSubId

int vtkAbstractInterpolatedVelocityField::LastSubId
| protected

Definition at line 278 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ LastClosestPoint

double vtkAbstractInterpolatedVelocityField::LastClosestPoint[3]
| protected

Definition at line 279 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ LastCellId

vtkIdType vtkAbstractInterpolatedVelocityField::LastCellId
| protected

Definition at line 280 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ LastDataSet

vtkDataSet* vtkAbstractInterpolatedVelocityField::LastDataSet
| protected

Definition at line 281 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ LastCell

vtkNew<vtkGenericCell> vtkAbstractInterpolatedVelocityField::LastCell
| protected

Definition at line 282 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ CurrentCell

vtkNew<vtkGenericCell> vtkAbstractInterpolatedVelocityField::CurrentCell
| protected

Definition at line 283 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ PointIds

vtkNew<vtkIdList> vtkAbstractInterpolatedVelocityField::PointIds
| protected

Definition at line 284 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ InitializationState

int vtkAbstractInterpolatedVelocityField::InitializationState
| protected

Make sure the velocity field is initialized: record the initialization strategy.

Definition at line 290 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ FindCellStrategy

vtkFindCellStrategy* vtkAbstractInterpolatedVelocityField::FindCellStrategy
| protected

Define a FindCell() strategy, keep track of the strategies (and other cached information) associated with each dataset.

Definition at line 314 of file vtkAbstractInterpolatedVelocityField.h.

## ◆ DataSetsInfo

std::vector<vtkDataSetInformation> vtkAbstractInterpolatedVelocityField::DataSetsInfo
| protected

Define a FindCell() strategy, keep track of the strategies (and other cached information) associated with each dataset.

Definition at line 315 of file vtkAbstractInterpolatedVelocityField.h.

The documentation for this class was generated from the following file:

- Filters/FlowPaths/vtkAbstractInterpolatedVelocityField.h